#include "cairot.h"
#include <cairo/cairo.h>
#include <math.h>
#include <stdio.h>

void draw(cairot_window_t window)
{
  int W, H; cairot_get_window_size(window, &W, &H);
  cairo_t* cr = cairo_for(window);

  cairo_save(cr);
  if (W > H) {
    cairo_translate(cr, 0, .5*(H-W));
    cairo_scale(cr, W, W);
  } else {
    cairo_translate(cr, .5*(W-H), 0);
    cairo_scale(cr, H, H);
  }

  cairo_pattern_t *pat;

  pat = cairo_pattern_create_linear (0.0, 0.0,  0.0, 1.0);
  cairo_pattern_add_color_stop_rgba (pat, 1, 0, 0, 0, 1);
  cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
  cairo_rectangle (cr, 0, 0, 1, 1);
  cairo_set_source (cr, pat);
  cairo_fill (cr);
  cairo_pattern_destroy (pat);

  pat = cairo_pattern_create_radial (115.2/256, 102.4/256, 25.6/256,
				     102.4/256, 102.4/256, 128.0/256);
  cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
  cairo_pattern_add_color_stop_rgba (pat, 1, 0, 0, 0, 1);
  cairo_set_source (cr, pat);
  cairo_arc (cr, .5, .5, .3, 0, 2 * M_PI);
  cairo_fill (cr);
  cairo_pattern_destroy (pat);

  cairo_restore(cr);

}

int main(int argc, char** argv)
{
  cairot_set_draw(draw);
  cairot_window_t window = cairot_create_window(300, 300);
  cairot_set_window_name(window, argv[0]);
  cairot_set_window_state(window, CAIROT_STATE_MAPPED);
  return cairot_run();
}
